<template>
  <q-banner inline-actions class="text-white bg-red q-my-md">
    Es muy importante mantener su información actualizada, especialmente su
    correo electrónico, ya que se utiliza para enviar información relacionada
    con su formación.
  </q-banner>

  <q-card class="q-mt-sm">
    <q-card-section>
      <div class="row q-col-gutter-xs">
        <div class="col-6">
          <div class="q-gutter-md">
            <q-input
              v-model="formData.email"
              label="Email"
              type="email"
              :error="validacion.has('email')"
              :error-message="validacion.first('email')"
            >
              <template v-slot:prepend>
                <q-icon name="alternate_email" />
              </template>
            </q-input>
            <q-input
              v-model="formData.profesion"
              label="Profesion"
              :error="validacion.has('profesion')"
              :error-message="validacion.first('profesion')"
            >
              <template v-slot:prepend>
                <q-icon name="work_outline" />
              </template>
            </q-input>
          </div>
        </div>
        <div class="col-6">
          <div class="q-gutter-md">
            <q-input
              v-model="formData.telefono"
              label="Telefono"
              :error="validacion.has('telefono')"
              :error-message="validacion.first('telefono')"
            >
              <template v-slot:prepend>
                <q-icon name="call" />
              </template>
            </q-input>
            <q-input
              v-model="formData.celular"
              label="Celular"
              :error="validacion.has('celular')"
              :error-message="validacion.first('celular')"
            >
              <template v-slot:prepend>
                <q-icon name="phone_iphone" />
              </template>
            </q-input>
          </div>
        </div>

        <div class="col-6">
          <div class="q-gutter-md">
            <q-input
              v-model="formData.totem"
              label="Totem"
              :error="validacion.has('totem')"
              :error-message="validacion.first('totem')"
            >
              <template v-slot:prepend>
                <q-icon name="pets" />
              </template>
            </q-input>
          </div>
        </div>

        <div class="col-12">
          <div class="q-gutter-md">
            <q-select
              v-model="formData.alimentacion_especial"
              style="min-width: 150px"
              dense
              filled
              emit-value
              stack-label
              map-options
              :options="[
                {
                  label: 'SI Tengo dieta especial',
                  value: 'S',
                },
                {
                  label: 'No tengo dieta especial',
                  value: 'N',
                },
              ]"
              label="Modalidad: "
              hide-bottom-space
              :error="validacion.has('modalidad')"
              :error-message="validacion.first('modalidad')"
            >
              <template v-slot:prepend>
                <q-icon name="restaurant" />
              </template>
            </q-select>

            <q-input
              v-if="formData.alimentacion_especial === 'S'"
              v-model="formData.alimentacion_especial_detalle"
              filled
              type="textarea"
              :error="validacion.has('alimentacion_especial_detalle')"
              :error-message="validacion.first('alimentacion_especial_detalle')"
            />
          </div>
        </div>
      </div>

      <div class="row q-col-gutter-xs q-mt-sm">
        <div class="col-12">
          <q-btn @click="actualizarDatos" class="full-width" color="green">
            Actualizar Datos
          </q-btn>
        </div>
      </div>

      <Loading :showing="loading" />
    </q-card-section>
  </q-card>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted } from 'vue';
import { api, validacion } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import Loading from 'src/components/Loading.vue';
import { useUserStore } from 'src/stores/user';

export default defineComponent({
  name: 'IndexPage',
  components: { Loading },
  setup() {
    const user = useUserStore();

    const loading = ref(true);
    const formData = ref({
      email: null,
      profesion: null,
      telefono: null,
      celular: null,
      totem: null,
      alimentacion_especial: null,
      alimentacion_especial_detalle: null,
    });

    onMounted(() => {
      getDatos();
    });

    function getDatos() {
      loading.value = true;
      api
        .get('/api/persona/datos')
        .then((response: AxiosResponse) => {
          formData.value = response.data;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function actualizarDatos() {
      loading.value = true;
      api.put('/api/persona/datos', formData.value).finally(() => {
        user.updateUser();
        loading.value = false;
      });
    }

    return { validacion, loading, formData, actualizarDatos };
  },
});
</script>
